/*
 * 运营中心角色
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.OpModels;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class SysAdminRoleOperateController : BaseController
    {
        public SysAdminRoleOperateController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }

        #region 运营中心角色列表

        /// <summary>
        /// 根据条件查询运营中心角色列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(SysAdminRole data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            string Condition = "";
            Condition += "Name:\"" + data.Name + "\",";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询运营中心角色列表

        /// <summary>
        /// 运营中心角色列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(SysAdminRole data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("Name", "2"); //名称

            Dictionary<string, object> obj = new AdminContentByConn(_accessor.HttpContext, PublicFunction.OpTables, OpConn).IndexData("SysAdminRole", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }
            return Json(obj);
        }

        #endregion

        #region 增加运营中心角色

        /// <summary>
        /// 增加或修改运营中心角色信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 增加运营中心角色

        /// <summary>
        /// 增加或修改运营中心角色信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(SysAdminRole data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Name", data.Name); //名称
            Fields.Add("Details", data.Details); //描述
            Fields.Add("RightInfo", "," + data.RightInfo + ","); //权限设置

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentByConn(_accessor.HttpContext, PublicFunction.OpTables, OpConn).Add("SysAdminRole", Fields, 0);
            AddSysLog(data.Id.ToString(), "SysAdminRole", "add");
            opdb.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改运营中心角色

        /// <summary>
        /// 增加或修改运营中心角色信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            SysAdminRole editData = opdb.SysAdminRole.FirstOrDefault(m => m.Id == Id) ?? new SysAdminRole();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改运营中心角色

        /// <summary>
        /// 增加或修改运营中心角色信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(SysAdminRole data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Name", data.Name); //名称
            Fields.Add("Details", data.Details); //描述
            Fields.Add("RightInfo", "," + data.RightInfo + ","); //权限设置

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentByConn(_accessor.HttpContext, PublicFunction.OpTables, OpConn).Edit("SysAdminRole", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "SysAdminRole", "update");
            opdb.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除运营中心角色信息

        /// <summary>
        /// 删除运营中心角色信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SysAdminRole", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentByConn(_accessor.HttpContext, PublicFunction.OpTables, OpConn).Edit("SysAdminRole", Fields, id);
            }
            opdb.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SysAdminRole", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentByConn(_accessor.HttpContext, PublicFunction.OpTables, OpConn).Edit("SysAdminRole", Fields, id);
            }
            opdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SysAdminRole", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentByConn(_accessor.HttpContext, PublicFunction.OpTables, OpConn).Edit("SysAdminRole", Fields, id);
            }
            opdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentByConn(_accessor.HttpContext, PublicFunction.OpTables, OpConn).Sort("SysAdminRole", Sort, Id);

            AddSysLog(Id.ToString(), "SysAdminRole", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                opdb.SysAdminRole.Add(new SysAdminRole()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                opdb.SaveChanges();
            }
            AddSysLog("0", "SysAdminRole", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(SysAdminRole data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Name", "2"); //名称

            Dictionary<string, object> obj = new AdminContentByConn(_accessor.HttpContext, PublicFunction.OpTables, OpConn).IndexData("SysAdminRole", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "SysAdminRole", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
